// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * Generation capability
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSCapability}
 */
public final class ESSCapability extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSCapability)
    ESSCapabilityOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSCapability.newBuilder() to construct.
  private ESSCapability(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSCapability() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSCapability();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapability_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapability_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSCapability.class, openfmb.essmodule.ESSCapability.Builder.class);
  }

  public static final int NAMEPLATEVALUE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.NameplateValue nameplateValue_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the nameplateValue field is set.
   */
  @java.lang.Override
  public boolean hasNameplateValue() {
    return nameplateValue_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return The nameplateValue.
   */
  @java.lang.Override
  public openfmb.commonmodule.NameplateValue getNameplateValue() {
    return nameplateValue_ == null ? openfmb.commonmodule.NameplateValue.getDefaultInstance() : nameplateValue_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.NameplateValueOrBuilder getNameplateValueOrBuilder() {
    return nameplateValue_ == null ? openfmb.commonmodule.NameplateValue.getDefaultInstance() : nameplateValue_;
  }

  public static final int ESSCAPABILITYRATINGS_FIELD_NUMBER = 2;
  private openfmb.essmodule.ESSCapabilityRatings essCapabilityRatings_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the essCapabilityRatings field is set.
   */
  @java.lang.Override
  public boolean hasEssCapabilityRatings() {
    return essCapabilityRatings_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The essCapabilityRatings.
   */
  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityRatings getEssCapabilityRatings() {
    return essCapabilityRatings_ == null ? openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance() : essCapabilityRatings_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityRatingsOrBuilder getEssCapabilityRatingsOrBuilder() {
    return essCapabilityRatings_ == null ? openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance() : essCapabilityRatings_;
  }

  public static final int ESSCAPABILITYCONFIGURATION_FIELD_NUMBER = 3;
  private openfmb.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
   * @return Whether the essCapabilityConfiguration field is set.
   */
  @java.lang.Override
  public boolean hasEssCapabilityConfiguration() {
    return essCapabilityConfiguration_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
   * @return The essCapabilityConfiguration.
   */
  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityConfiguration getEssCapabilityConfiguration() {
    return essCapabilityConfiguration_ == null ? openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance() : essCapabilityConfiguration_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
   */
  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityConfigurationOrBuilder getEssCapabilityConfigurationOrBuilder() {
    return essCapabilityConfiguration_ == null ? openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance() : essCapabilityConfiguration_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (nameplateValue_ != null) {
      output.writeMessage(1, getNameplateValue());
    }
    if (essCapabilityRatings_ != null) {
      output.writeMessage(2, getEssCapabilityRatings());
    }
    if (essCapabilityConfiguration_ != null) {
      output.writeMessage(3, getEssCapabilityConfiguration());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (nameplateValue_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getNameplateValue());
    }
    if (essCapabilityRatings_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getEssCapabilityRatings());
    }
    if (essCapabilityConfiguration_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getEssCapabilityConfiguration());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSCapability)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSCapability other = (openfmb.essmodule.ESSCapability) obj;

    if (hasNameplateValue() != other.hasNameplateValue()) return false;
    if (hasNameplateValue()) {
      if (!getNameplateValue()
          .equals(other.getNameplateValue())) return false;
    }
    if (hasEssCapabilityRatings() != other.hasEssCapabilityRatings()) return false;
    if (hasEssCapabilityRatings()) {
      if (!getEssCapabilityRatings()
          .equals(other.getEssCapabilityRatings())) return false;
    }
    if (hasEssCapabilityConfiguration() != other.hasEssCapabilityConfiguration()) return false;
    if (hasEssCapabilityConfiguration()) {
      if (!getEssCapabilityConfiguration()
          .equals(other.getEssCapabilityConfiguration())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasNameplateValue()) {
      hash = (37 * hash) + NAMEPLATEVALUE_FIELD_NUMBER;
      hash = (53 * hash) + getNameplateValue().hashCode();
    }
    if (hasEssCapabilityRatings()) {
      hash = (37 * hash) + ESSCAPABILITYRATINGS_FIELD_NUMBER;
      hash = (53 * hash) + getEssCapabilityRatings().hashCode();
    }
    if (hasEssCapabilityConfiguration()) {
      hash = (37 * hash) + ESSCAPABILITYCONFIGURATION_FIELD_NUMBER;
      hash = (53 * hash) + getEssCapabilityConfiguration().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSCapability parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapability parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapability parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapability parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSCapability prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation capability
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSCapability}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSCapability)
      openfmb.essmodule.ESSCapabilityOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapability_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapability_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSCapability.class, openfmb.essmodule.ESSCapability.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSCapability.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      nameplateValue_ = null;
      if (nameplateValueBuilder_ != null) {
        nameplateValueBuilder_.dispose();
        nameplateValueBuilder_ = null;
      }
      essCapabilityRatings_ = null;
      if (essCapabilityRatingsBuilder_ != null) {
        essCapabilityRatingsBuilder_.dispose();
        essCapabilityRatingsBuilder_ = null;
      }
      essCapabilityConfiguration_ = null;
      if (essCapabilityConfigurationBuilder_ != null) {
        essCapabilityConfigurationBuilder_.dispose();
        essCapabilityConfigurationBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapability_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapability getDefaultInstanceForType() {
      return openfmb.essmodule.ESSCapability.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapability build() {
      openfmb.essmodule.ESSCapability result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapability buildPartial() {
      openfmb.essmodule.ESSCapability result = new openfmb.essmodule.ESSCapability(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSCapability result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.nameplateValue_ = nameplateValueBuilder_ == null
            ? nameplateValue_
            : nameplateValueBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.essCapabilityRatings_ = essCapabilityRatingsBuilder_ == null
            ? essCapabilityRatings_
            : essCapabilityRatingsBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.essCapabilityConfiguration_ = essCapabilityConfigurationBuilder_ == null
            ? essCapabilityConfiguration_
            : essCapabilityConfigurationBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSCapability) {
        return mergeFrom((openfmb.essmodule.ESSCapability)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSCapability other) {
      if (other == openfmb.essmodule.ESSCapability.getDefaultInstance()) return this;
      if (other.hasNameplateValue()) {
        mergeNameplateValue(other.getNameplateValue());
      }
      if (other.hasEssCapabilityRatings()) {
        mergeEssCapabilityRatings(other.getEssCapabilityRatings());
      }
      if (other.hasEssCapabilityConfiguration()) {
        mergeEssCapabilityConfiguration(other.getEssCapabilityConfiguration());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getNameplateValueFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getEssCapabilityRatingsFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getEssCapabilityConfigurationFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.NameplateValue nameplateValue_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.NameplateValue, openfmb.commonmodule.NameplateValue.Builder, openfmb.commonmodule.NameplateValueOrBuilder> nameplateValueBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the nameplateValue field is set.
     */
    public boolean hasNameplateValue() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return The nameplateValue.
     */
    public openfmb.commonmodule.NameplateValue getNameplateValue() {
      if (nameplateValueBuilder_ == null) {
        return nameplateValue_ == null ? openfmb.commonmodule.NameplateValue.getDefaultInstance() : nameplateValue_;
      } else {
        return nameplateValueBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setNameplateValue(openfmb.commonmodule.NameplateValue value) {
      if (nameplateValueBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        nameplateValue_ = value;
      } else {
        nameplateValueBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setNameplateValue(
        openfmb.commonmodule.NameplateValue.Builder builderForValue) {
      if (nameplateValueBuilder_ == null) {
        nameplateValue_ = builderForValue.build();
      } else {
        nameplateValueBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeNameplateValue(openfmb.commonmodule.NameplateValue value) {
      if (nameplateValueBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          nameplateValue_ != null &&
          nameplateValue_ != openfmb.commonmodule.NameplateValue.getDefaultInstance()) {
          getNameplateValueBuilder().mergeFrom(value);
        } else {
          nameplateValue_ = value;
        }
      } else {
        nameplateValueBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearNameplateValue() {
      bitField0_ = (bitField0_ & ~0x00000001);
      nameplateValue_ = null;
      if (nameplateValueBuilder_ != null) {
        nameplateValueBuilder_.dispose();
        nameplateValueBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.NameplateValue.Builder getNameplateValueBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getNameplateValueFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.NameplateValueOrBuilder getNameplateValueOrBuilder() {
      if (nameplateValueBuilder_ != null) {
        return nameplateValueBuilder_.getMessageOrBuilder();
      } else {
        return nameplateValue_ == null ?
            openfmb.commonmodule.NameplateValue.getDefaultInstance() : nameplateValue_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.NameplateValue nameplateValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.NameplateValue, openfmb.commonmodule.NameplateValue.Builder, openfmb.commonmodule.NameplateValueOrBuilder> 
        getNameplateValueFieldBuilder() {
      if (nameplateValueBuilder_ == null) {
        nameplateValueBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.NameplateValue, openfmb.commonmodule.NameplateValue.Builder, openfmb.commonmodule.NameplateValueOrBuilder>(
                getNameplateValue(),
                getParentForChildren(),
                isClean());
        nameplateValue_ = null;
      }
      return nameplateValueBuilder_;
    }

    private openfmb.essmodule.ESSCapabilityRatings essCapabilityRatings_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSCapabilityRatings, openfmb.essmodule.ESSCapabilityRatings.Builder, openfmb.essmodule.ESSCapabilityRatingsOrBuilder> essCapabilityRatingsBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the essCapabilityRatings field is set.
     */
    public boolean hasEssCapabilityRatings() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The essCapabilityRatings.
     */
    public openfmb.essmodule.ESSCapabilityRatings getEssCapabilityRatings() {
      if (essCapabilityRatingsBuilder_ == null) {
        return essCapabilityRatings_ == null ? openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance() : essCapabilityRatings_;
      } else {
        return essCapabilityRatingsBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEssCapabilityRatings(openfmb.essmodule.ESSCapabilityRatings value) {
      if (essCapabilityRatingsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        essCapabilityRatings_ = value;
      } else {
        essCapabilityRatingsBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEssCapabilityRatings(
        openfmb.essmodule.ESSCapabilityRatings.Builder builderForValue) {
      if (essCapabilityRatingsBuilder_ == null) {
        essCapabilityRatings_ = builderForValue.build();
      } else {
        essCapabilityRatingsBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeEssCapabilityRatings(openfmb.essmodule.ESSCapabilityRatings value) {
      if (essCapabilityRatingsBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          essCapabilityRatings_ != null &&
          essCapabilityRatings_ != openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance()) {
          getEssCapabilityRatingsBuilder().mergeFrom(value);
        } else {
          essCapabilityRatings_ = value;
        }
      } else {
        essCapabilityRatingsBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearEssCapabilityRatings() {
      bitField0_ = (bitField0_ & ~0x00000002);
      essCapabilityRatings_ = null;
      if (essCapabilityRatingsBuilder_ != null) {
        essCapabilityRatingsBuilder_.dispose();
        essCapabilityRatingsBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.essmodule.ESSCapabilityRatings.Builder getEssCapabilityRatingsBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getEssCapabilityRatingsFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.essmodule.ESSCapabilityRatingsOrBuilder getEssCapabilityRatingsOrBuilder() {
      if (essCapabilityRatingsBuilder_ != null) {
        return essCapabilityRatingsBuilder_.getMessageOrBuilder();
      } else {
        return essCapabilityRatings_ == null ?
            openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance() : essCapabilityRatings_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityRatings essCapabilityRatings = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSCapabilityRatings, openfmb.essmodule.ESSCapabilityRatings.Builder, openfmb.essmodule.ESSCapabilityRatingsOrBuilder> 
        getEssCapabilityRatingsFieldBuilder() {
      if (essCapabilityRatingsBuilder_ == null) {
        essCapabilityRatingsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.essmodule.ESSCapabilityRatings, openfmb.essmodule.ESSCapabilityRatings.Builder, openfmb.essmodule.ESSCapabilityRatingsOrBuilder>(
                getEssCapabilityRatings(),
                getParentForChildren(),
                isClean());
        essCapabilityRatings_ = null;
      }
      return essCapabilityRatingsBuilder_;
    }

    private openfmb.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSCapabilityConfiguration, openfmb.essmodule.ESSCapabilityConfiguration.Builder, openfmb.essmodule.ESSCapabilityConfigurationOrBuilder> essCapabilityConfigurationBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     * @return Whether the essCapabilityConfiguration field is set.
     */
    public boolean hasEssCapabilityConfiguration() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     * @return The essCapabilityConfiguration.
     */
    public openfmb.essmodule.ESSCapabilityConfiguration getEssCapabilityConfiguration() {
      if (essCapabilityConfigurationBuilder_ == null) {
        return essCapabilityConfiguration_ == null ? openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance() : essCapabilityConfiguration_;
      } else {
        return essCapabilityConfigurationBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public Builder setEssCapabilityConfiguration(openfmb.essmodule.ESSCapabilityConfiguration value) {
      if (essCapabilityConfigurationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        essCapabilityConfiguration_ = value;
      } else {
        essCapabilityConfigurationBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public Builder setEssCapabilityConfiguration(
        openfmb.essmodule.ESSCapabilityConfiguration.Builder builderForValue) {
      if (essCapabilityConfigurationBuilder_ == null) {
        essCapabilityConfiguration_ = builderForValue.build();
      } else {
        essCapabilityConfigurationBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public Builder mergeEssCapabilityConfiguration(openfmb.essmodule.ESSCapabilityConfiguration value) {
      if (essCapabilityConfigurationBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          essCapabilityConfiguration_ != null &&
          essCapabilityConfiguration_ != openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance()) {
          getEssCapabilityConfigurationBuilder().mergeFrom(value);
        } else {
          essCapabilityConfiguration_ = value;
        }
      } else {
        essCapabilityConfigurationBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public Builder clearEssCapabilityConfiguration() {
      bitField0_ = (bitField0_ & ~0x00000004);
      essCapabilityConfiguration_ = null;
      if (essCapabilityConfigurationBuilder_ != null) {
        essCapabilityConfigurationBuilder_.dispose();
        essCapabilityConfigurationBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public openfmb.essmodule.ESSCapabilityConfiguration.Builder getEssCapabilityConfigurationBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getEssCapabilityConfigurationFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    public openfmb.essmodule.ESSCapabilityConfigurationOrBuilder getEssCapabilityConfigurationOrBuilder() {
      if (essCapabilityConfigurationBuilder_ != null) {
        return essCapabilityConfigurationBuilder_.getMessageOrBuilder();
      } else {
        return essCapabilityConfiguration_ == null ?
            openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance() : essCapabilityConfiguration_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSCapabilityConfiguration essCapabilityConfiguration = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSCapabilityConfiguration, openfmb.essmodule.ESSCapabilityConfiguration.Builder, openfmb.essmodule.ESSCapabilityConfigurationOrBuilder> 
        getEssCapabilityConfigurationFieldBuilder() {
      if (essCapabilityConfigurationBuilder_ == null) {
        essCapabilityConfigurationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.essmodule.ESSCapabilityConfiguration, openfmb.essmodule.ESSCapabilityConfiguration.Builder, openfmb.essmodule.ESSCapabilityConfigurationOrBuilder>(
                getEssCapabilityConfiguration(),
                getParentForChildren(),
                isClean());
        essCapabilityConfiguration_ = null;
      }
      return essCapabilityConfigurationBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSCapability)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSCapability)
  private static final openfmb.essmodule.ESSCapability DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSCapability();
  }

  public static openfmb.essmodule.ESSCapability getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSCapability>
      PARSER = new com.google.protobuf.AbstractParser<ESSCapability>() {
    @java.lang.Override
    public ESSCapability parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSCapability> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSCapability> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSCapability getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

